Attribute VB_Name = "Modul2"
Public Sub DimEdit()

Dim App As Application
Dim ActDr As Drawing
Dim Grs As Graphics
Dim Gr As Graphic
Dim Vers As Vertices
Dim Ver As Vertex
Dim ObjSel As Selection
Dim NumSel As Long, i As Long
Dim GrSelType As String
Dim LinLg As Single
Dim eingabe As String

    Set App = IMSIGX.Application    'Returns base application - TurboCAD
    Set ActDr = App.ActiveDrawing   'Returns Active Drawing
    Set ObjSel = ActDr.Selection    'Returns Selected objects as Selection collection
    NumSel = ObjSel.Count   'Returns the number of items in the collection.

 If NumSel = 0 Then
        MsgBox ("Es wurde keine Malinie ausgewhlt!")
        Exit Sub
    End If
    
'Hier mu noch Auswahl der Linienlnge anhand des Zeichnungsmastabes rein.
'masstab = actdr.
eingabe = InputBox("Geben Sie die Lnge der Hilfslinien ein", "DimEdit")
LinLg = CDbl(eingabe)

For i = 0 To NumSel - 1
Set Gr = ObjSel.Item(i) 'Returns part of a collection - graphic in the selection collection
        GrSelType = Gr.Type
        If GrSelType = "TCW25DimLin" Then
            Set Vers = Gr.Graphics.Item(1) 'Whlt die erste Hilfslinie
                    
            Dim X1!, Y1!, X2!, Y2!  'Koordinaten der Linien
            Dim DelVer As Vertex
            Dim NewVer As Vertex
            
            Set Ver = Vers.Item(0) 'Punktauswahl Hilfslinie1
            X1 = Ver.X
            Y1 = Ver.Y
        
            Set Ver = Vers.Item(1)
            X2 = Ver.X
            Y2 = Ver.Y
            
            If X1 = X2 And Y2 > Y1 Then  'berprfung ob horizontale Malinie nach oben ausgerichtet
                
                Y1 = Y2 - LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                       
            Set Vers = Gr.Graphics.Item(2) 'Whlt die zweite Hilfslinie
                   
            Set Ver = Vers.Item(0) 'Punktauswahl Hilfslinie2
                
                X1 = Ver.X
                Y1 = Y2 - LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                                 
            End If
            
            If X1 = X2 And Y1 > Y2 Then  'berprfung ob horizontale Malinie nach unten ausgerichtet
                
                Y1 = Y2 + LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                       
            Set Vers = Gr.Graphics.Item(2) 'Whlt die zweite Hilfslinie
                   
            Set Ver = Vers.Item(0) 'Punktauswahl Hilfslinie2
                
                X1 = Ver.X
                Y1 = Y2 + LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                                 
            End If
            
            If Y1 = Y2 And X1 > X2 Then  'berprfung ob vertikale Malinie nach links ausgerichtet
                
                X1 = X2 + LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                       
            Set Vers = Gr.Graphics.Item(2) 'Whlt die zweite Hilfslinie
                   
            Set Ver = Vers.Item(0) 'Punktauswahl Hilfslinie2
                
                Y1 = Ver.Y
                X1 = X2 + LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                                 
            End If
            
            If Y1 = Y2 And X2 > X1 Then  'berprfung ob vertikale Malinie nach rechts ausgerichtet
                
                X1 = X2 - LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                       
            Set Vers = Gr.Graphics.Item(2) 'Whlt die zweite Hilfslinie
                   
            Set Ver = Vers.Item(0) 'Punktauswahl Hilfslinie2
                
                Y1 = Ver.Y
                X1 = X2 - LinLg
                Set NewVer = Vers.Add(X1, Y1, 0, , , , , , , 1) 'Setzt neuen Vertex als Enpunkt
                Set DelVer = Vers.Remove(0)                     'Lscht alten Punkt
                                 
            End If
        
        ActDr.Views(0).Refresh
        
        End If
Next i
ActDr.UnselectAll
End Sub
